"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.tryGetRegistrar = exports.tryGetVoter = exports.getVoterWeightPDA = exports.getVoterPDA = exports.getRegistrarPDA = exports.emptyPk = void 0;
const web3_js_1 = require("@solana/web3.js");
exports.emptyPk = '11111111111111111111111111111111';
const getRegistrarPDA = async (realmPk, mint, clientProgramId) => {
    const [registrar, registrarBump] = await web3_js_1.PublicKey.findProgramAddress([realmPk.toBuffer(), Buffer.from('registrar'), mint.toBuffer()], clientProgramId);
    return {
        registrar,
        registrarBump,
    };
};
exports.getRegistrarPDA = getRegistrarPDA;
const getVoterPDA = async (registrar, walletPk, clientProgramId) => {
    const [voter, voterBump] = await web3_js_1.PublicKey.findProgramAddress([registrar.toBuffer(), Buffer.from('voter'), walletPk.toBuffer()], clientProgramId);
    return {
        voter,
        voterBump,
    };
};
exports.getVoterPDA = getVoterPDA;
const getVoterWeightPDA = async (registrar, walletPk, clientProgramId) => {
    const [voterWeightPk, voterWeightBump] = await web3_js_1.PublicKey.findProgramAddress([
        registrar.toBuffer(),
        Buffer.from('voter-weight-record'),
        walletPk.toBuffer(),
    ], clientProgramId);
    return {
        voterWeightPk,
        voterWeightBump,
    };
};
exports.getVoterWeightPDA = getVoterWeightPDA;
const tryGetVoter = async (voterPk, client) => {
    try {
        const voter = await client?.program.account.voter.fetch(voterPk);
        return voter;
    }
    catch (e) {
        return null;
    }
};
exports.tryGetVoter = tryGetVoter;
const tryGetRegistrar = async (registrarPk, client) => {
    try {
        const existingRegistrar = await client.program.account.registrar.fetch(registrarPk);
        return existingRegistrar;
    }
    catch (e) {
        return null;
    }
};
exports.tryGetRegistrar = tryGetRegistrar;
